//A clock mode that makes making clocks easier.
//By Bleh.  Delete this file to uninstall.


function serverCmdToggleWandMode(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		%client.WandMode++;
		if(%client.WandMode > 6)
		{
			%client.WandMode = 0;
		}

	if(%client.WandMode == 0)
	{
		messageClient(%client,"","\c2Wand in Destroy-Mode");
	}
	if(%client.WandMode == 1)
	{
		messageClient(%client,"","\c2Wand in Teleport-Mode");
	}
	if(%client.WandMode == 2)
	{
		messageClient(%client,"","\c2Wand in Safe-Brick-Mode");
	}
	if(%client.WandMode == 3)
	{
		messageClient(%client,"","\c2Wand in Cloak-Mode");
	}
	if(%client.WandMode == 4)
	{
		messageClient(%client,"","\c2Wand in Jail-Mode");
	}
	if(%client.WandMode == 5)
	{
		messageClient(%client,"","\c2Wand in Destroy-By-Owner-Mode");
	}
	if(%client.WandMode == 6)
	{
		messageClient(%client,"","\c2Wand in Clock-Mode");
	}
	}
}

function wandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if(%obj.client.isAdmin || %obj.client.isSuperAdmin || %obj.client.isTempAdmin)
	{ 
		%player = %obj.client.player;

		//if theres no player, (or client) bail out now
		if(!%player)
			return;

		if (%col.getClassName() !$= "StaticShape")
			return;

		%colData = %col.getDataBlock();
		%colDataClass = %colData.classname;
		
		if(%colDataClass $= "brick")
		{
			if(%obj.client.WandMode == 0)
			{
				killBrick(%col);
			}
			if(%obj.client.WandMode == 1)
			{
				if(%col.teleportObj == 0)
				{
				if(%obj.client.teleHits == 0)	
				{
					$Pref::Game::TotalTelePortLinks++;
					%obj.client.teleHits++;
					%col.teleportObj = $Pref::Game::TotalTelePortLinks;
					messageClient(%obj.client,"","\c4Set first teleport link");
				}
				else
				{
					%obj.client.teleHits = 0;
					%col.teleportObj = $Pref::Game::TotalTelePortLinks;
					messageClient(%obj.client,"","\c4Set second teleport link");
					//schedule(500,0,"Telepulse",%col);
				}
				}
				else
				{
					%col.teleportObj = 0;
					messageClient(%obj.client,"","\c4Removed teleport link");
				}
			}
			if(%obj.client.WandMode == 2)
			{
				if(%col.NoDestroy == 0)
				{
					%col.NoDestroy = 1;
					messageClient(%obj.client,"","\c4Made brick safe from deathmatch weapons");
				}
				else
				{
					%col.NoDestroy = 0;
					messageClient(%obj.client,"","\c4Brick is no longer safe from deathmatch weapons");
				}

			}
		if(%obj.client.WandMode == 6)
		{
			CenterPrint(%obj.client,"Created a clock.", 5, 1);
			OrigClockNit(%col);
		}
		}
		if(%obj.client.WandMode == 3)
		{
			if(%col.iswcloaked != 0 && %col.iswcloaked != 1)
			{
				%col.setcloaked(1);
				%col.iswcloaked = 1;
			}
			else if(%col.iswcloaked == 0)
			{
				%col.setcloaked(1);
				%col.iswcloaked = 1;
			}
			else if(%col.iswcloaked == 1)
			{
				%col.setcloaked(0);
				%col.iswcloaked = 0;
			}
		}
		if(%obj.client.WandMode == 4)
		{
			if(%col.isDetBrick $= 1)
			{
				%col.isDetBrick = 0;
				messageClient(%obj.client,"","\c4Removed Jail Spawn.");
			}
			else
			{
			%col.isDetBrick = 1;
			messageClient(%obj.client,"","\c4Assigned Jail Spawn.");
			}
		}


		if(%obj.client.WandMode == 5)
		{
			%owner = %col.ownername;
			%ownerip = %col.ownerip;
			commandtoclient(%obj.client,'openBP',%owner,%ownerip);
		}
	}
}


function OrigClockNit(%obj)
{
if (!isObject(%obj))
{
return;
}
	%rot = %obj.eulerrot;
	if(%rot $= "")
		%rot = "0 0 0";
	%zrot = getword(%rot,2);
	%yrot = getword(%rot,1);
	%pos = %obj.gettransform();
	%handpos = %pos;
	if (!%obj.HandsCreated)
	{
	%obj.SecHand = new StaticShape()
	{
		datablock = staticbrick1x1;
		scale = ".5 .5 3";
	};
	%obj.MinHand = new StaticShape()
	{
		datablock = staticbrick1x1;
		scale = ".3 .5 4";
	};
	%obj.HourHand = new StaticShape()
	{
		datablock = staticbrick1x1;
		scale = ".1 .5 2";
	};
	%obj.setScale("2 1 1");
	%obj.HourHand.setSkinName("Black");
	%obj.MinHand.setSkinName("Black");
	%obj.SecHand.setSkinName("Red");
	%obj.HandsCreated = 1;
	%obj.ClockSeconds = -1;
	%obj.ClockMinutes = 0;
	%obj.ClockHours = 0;
	}
	%obj.ClockSeconds++;
	if (%obj.ClockSeconds > 59)
	{
	%obj.ClockSeconds = 0;
	%obj.ClockMinutes++;
	}
	if (%obj.ClockMinutes > 59)
	{
	%obj.ClockMinutes = 0;
	%obj.ClockHours += 5;
	}
	if (%obj.ClockHours > 59)
	{
	%obj.ClockHours = 0;
	}
	%CSRotB = 6 * %obj.ClockSeconds SPC %yrot SPC %zrot;
	%CMRotB = 6 * %obj.ClockMinutes SPC %yrot SPC %zrot;
	%CHRotB = 6 * %obj.ClockHours SPC %yrot SPC %zrot;
//	echo(%CSRotB);
	%BasePos = getWords(%handpos, 0, 2);
//	echo(%basePos SPC eulerToQuat(%CSRotB));
	%obj.SecHand.setTransform(%basePos SPC eulerToQuat(%CSRotB));
	%obj.MinHand.setTransform(%basePos SPC eulerToQuat(%CMRotB));
	%obj.HourHand.setTransform(%basePos SPC eulerToQuat(%CHRotB));
	%obj.SecHand.setShapeName(%obj.ClockSeconds);
	%obj.MinHand.setShapeName(%obj.ClockMinutes);
	%obj.HourHand.setShapeName(%obj.ClockHours / 5);
	%obj.setshapename(%obj.ClockHours / 5 @ " : " @ %obj.ClockMinutes @ " : " @ %obj.clockseconds);
schedule(1000, 0, "OrigClockNit", %obj);
}